function output = gen_spiral(numPosSamples, numNegSamples)

% parameters
start = 90;         % determines how far from the origin the spirals start, in degrees
noise = 2.0;        % displaces the instances from the spiral
degrees = 350;      % controls the length of the spirals

% degrees
deg2rad = (2*pi)/360;
start = start * deg2rad;

% spiral 1
theta = start + sqrt(rand(numPosSamples,1)) * degrees * deg2rad;
d1 = [-cos(theta).*theta + rand(numPosSamples,1)*noise, sin(theta).*theta + rand(numPosSamples,1)*noise, -1*ones(numPosSamples,1)];

% spiral 2
theta = start + sqrt(rand(numNegSamples,1)) * degrees * deg2rad;
d2 = [cos(theta).*theta + rand(numNegSamples,1)*noise, -sin(theta).*theta + rand(numNegSamples,1)*noise, +1*ones(numNegSamples,1)];

% samples
samples = [d1;d2];

% normalization
tmp = samples(:,1:2);
tmp = tmp - min(tmp(:));
tmp = tmp./max(tmp(:));
samples(:,1:2) = tmp;

% random order
indexes = randperm(size(samples,1));
samples = samples(indexes,:);

% output
output = samples;
end
