function [preds, L] = test_adaboost(adaboost_model, te_func_handle, test_set)
%
% ADABOOST TESTING
%
nr_weak      = length(adaboost_model.weights);    % Weak learner  
nr_test      = size(test_set,1);                  % Test data  
nr_class     = 2;                                 % Class  
temp_L       = zeros(nr_test, nr_class, nr_weak); %  Weak learner likelihood

for i = 1:nr_weak
    %  weak learner Likelihood Ѵ. 
	[temp_L(:,:,i), ~, ~] ...
        = te_func_handle(adaboost_model.parameters{i}, test_set, ones(nr_test,1));
	temp_L(:,:,i) = temp_L(:,:,i)*adaboost_model.weights(i);
end

L     = sum(temp_L, 3); 
preds = likelihood2class(L); 

